#include <stdio.h>

#include <qevent.h>

extern int keymap[];

#include "mainwidget.h"

MainWidget::MainWidget(QWidget *parent)
    : QWidget(parent, "MainWidget"), m_Keymap(10000)
    {
     m_Keymap.fill(0);
     m_Keymap[(int)Qt::Key_Escape] = K_ESC;
     m_Keymap[(int)Qt::Key_Left] = K_LEFT;
     m_Keymap[(int)Qt::Key_Right] = K_RIGHT;
     m_Keymap[(int)Qt::Key_Up] = K_UP;
     m_Keymap[(int)Qt::Key_Down] = K_DOWN;
     m_Keymap[(int)Qt::Key_Enter] = K_ENTER;
     m_Keymap[(int)Qt::Key_Return] = K_ENTER; // start
     m_Keymap[Qt::Key_L] = (int)'s';          // b
     m_Keymap[Qt::Key_J] = (int)'d';          // a
     m_Keymap[Qt::Key_Space] = K_SPACE;       // select
    }
    
MainWidget::~MainWidget()
{
}

void MainWidget::keyPressEvent(QKeyEvent *e)
{
    //printf("MainWidget::keyPressEvent: %d\n", e->key());
    
    event_t ev;
    int keyCode = m_Keymap[e->key()];
    
    if (keyCode != 0)
    {
        ev.type = EV_PRESS;
        ev.code = keyCode;
        ev_postevent(&ev);
    }
    else
        printf("MainWidget::keyPressEvent: couldn't map\n");
    
    e->accept();
    QWidget::keyPressEvent(e);
}

void MainWidget::keyReleaseEvent(QKeyEvent *e)
{
    //printf("MainWidget::keyReleaseEvent: %d\n", e->key());
    
    event_t ev;
   
    ev.type = EV_RELEASE; 
    ev.code = m_Keymap[e->key()];
    ev_postevent(&ev);
    
    e->accept();
    QWidget::keyReleaseEvent(e);
}

void MainWidget::closeEvent(QCloseEvent *e)
{
    printf("MainWidget::closeEvent\n");
    
    // Trying to exit, tell the emulator
    event_t ev;
    ev.type = EV_PRESS;
    ev.code = K_ESC;
    
    ev_postevent(&ev);
    
    e->ignore();
    QWidget::closeEvent(e);
}
